'use strict';

/* App Module */ 

var myApp = angular.module('ausomesports', ['ngRoute','ngCordova','ngCordovaOauth','ausomesportsFilters', 'historyServices', 'ui.bootstrap', 'c12o16h1.pullDownToRefresh','ngSanitize','ngAnimate', 'ngTouch']);

myApp.config(['$httpProvider', function($httpProvider) {
        $httpProvider.defaults.useXDomain = true;
        delete $httpProvider.defaults.headers.common['X-Requested-With'];
  }]);


myApp.config(['$routeProvider', function($routeProvider) {
  $routeProvider.
      when('/appStart', {templateUrl: 'appStart.html',   controller: appStartCtrl}).
      when('/homePage', {templateUrl: 'homePage.html',   controller: homePageCtrl}).
      when('/getChallenges/:mine', {templateUrl: 'getChallenges.html',   controller: getChallengesCtrl}).
      when('/myPicks', {templateUrl: 'myPicks.html',   controller: myPicksCtrl}).
      when('/getGames', {templateUrl: 'getGames.html',   controller: getGamesCtrl}).
      when('/refreshGames', {templateUrl: 'getGames.html',   controller: refreshGamesCtrl}).
      when('/challenge/:index', {templateUrl: 'challenge.html',   controller: challengeCtrl}).
      when('/stats', {templateUrl: 'stats.html',   controller: statsCtrl}).
      when('/rank', {templateUrl: 'rank.html',   controller: rankCtrl}).
      when('/filter', {templateUrl: 'filter.html',   controller: filterCtrl}).
      when('/setting', {templateUrl: 'setting.html',   controller: settingCtrl}).
      when('/friend', {templateUrl: 'friend.html',   controller: friendCtrl}).
      when('/talk', {templateUrl: 'talk.html',   controller: talkCtrl}).
      when('/comment', {templateUrl: 'comment.html',   controller: commentCtrl}).
      when('/signOut', {templateUrl: 'signOut.html',   controller: signOutCtrl}).
      when('/update', {templateUrl: 'update.html',   controller: updateCtrl}).
      /* old controls */
      when('/tour', {templateUrl: 'tour.html',   controller: TourCtrl}).
      otherwise({redirectTo: '/appStart'});
}]);
