/* global passData */
/* global footerCnt */
/* global GuserInfo */


function pickInfo() {
    var picks = {
        total: 0,
        right: 0,
        wrong: 0,
        tbd: 0,
        right_pct: 0,
        wrong_pct: 0,
        tbd_pct: 0,
        sportRight: {},
        sportWrong: {}
    };
    picks.sportRight = new Map();
    picks.sportWrong = new Map();
    for (var i = 0; i < passData.picks.length; i++) {
        picks.total++;
        if (passData.picks[i].result === passData.picks[i].myPick) {
            picks.right++;
            var cnt = picks.sportRight.get(passData.picks[i].sport);
            if (cnt) {
                cnt++;
                picks.sportRight.set(passData.picks[i].sport, cnt);
            } else {
                var idx = passData.statSport.indexOf(passData.picks[i].sport);
                if (idx < 0) {
                    passData.statSport.push(passData.picks[i].sport);
                }
                picks.sportRight.set(passData.picks[i].sport, 1);
            }

        } else if (passData.picks[i].result === passData.picks[i].oppPick) {
            picks.wrong++;
            var cnt = picks.sportWrong.get(passData.picks[i].sport);
            if (cnt) {
                cnt++;
                picks.sportWrong.set(passData.picks[i].sport, cnt);
            } else {
                var idx = passData.statSport.indexOf(passData.picks[i].sport);
                if (idx < 0) {
                    passData.statSport.push(passData.picks[i].sport);
                }
                picks.sportWrong.set(passData.picks[i].sport, 1);
            }
        } else {
            picks.tbd++;
        }
    }
    picks.right_pct = Math.round((picks.right * 100) / (picks.right + picks.wrong));
    picks.wrong_pct = Math.round((picks.wrong * 100) / (picks.right + picks.wrong));
    picks.tbd_pct = Math.round((picks.tbd * 100) / picks.total);
    return picks;
}


function chartStats(name, labels, statData, bcolors, hcolors) {
    var id = "Chart".concat(name);
    var ctx = document.getElementById(id);
    var data = {
        labels: labels,
        datasets: [
            {
                data: statData,
                backgroundColor: bcolors,
                hoverBackgroundColor: hcolors
            }]
    };
    var Charts = new Chart(ctx, {
        type: 'pie',
        data: data,
        options: {
            legend: {
                fullWidth: false,
                labels: {
                    boxWidth: 10
                }
            }
        },
        animation: {
            animateRotate: true}
    });
}
function challengeInfo(data) {
    var c = {
        acceptedTotal: 0,
        acceptedRight: 0,
        acceptedWrong: 0,
        acceptedTbd: 0,
        rejectedTotal: 0,
        rejectedRight: 0,
        rejectedWrong: 0,
        rejectedTbd: 0,
        pending: 0,
        sent: 0,
        acceptedRight_pct: 0,
        acceptedWrong_pct: 0,
        sportRight: {},
        sportWrong: {}
    };
    c.sportRight = new Map();
    c.sportWrong = new Map();
    if (data === null) {
        return c;
    }
    for (var i = 0; i < data.length; i++) {
        if (data[i].status === "accepted") {
            c.acceptedTotal++;
            if (data[i].result === data[i].myPick) {
                c.acceptedRight++;
                var cnt = c.sportRight.get(data[i].sport);
                if (cnt) {
                    cnt++;
                    c.sportRight.set(data[i].sport, cnt);
                } else {
                    var idx = passData.statSport.indexOf(data[i].sport);
                    if (idx < 0) {
                        passData.statSport.push(data[i].sport);
                    }
                    c.sportRight.set(data[i].sport, 1);
                }
            } else if (data[i].result === data[i].oppPick) {
                c.acceptedWrong++;
                var cnt = c.sportWrong.get(data[i].sport);
                if (cnt) {
                    cnt++;
                    c.sportWrong.set(data[i].sport, cnt);
                } else {
                    var idx = passData.statSport.indexOf(data[i].sport);
                    if (idx < 0) {
                        passData.statSport.push(data[i].sport);
                    }
                    c.sportWrong.set(data[i].sport, 1);
                }
            } else {
                c.acceptedTbd++;
            }
        } else if (data[i].status === "rejected") {
            c.rejectedTotal++;
            if (data[i].result === data[i].myPick) {
                c.rejectedRight++;
            } else if (data[i].result === data[i].oppPick) {
                c.rejectedWrong++;
            } else {
                c.rejectedTbd++;
            }
        } else if (data[i].status === "send") {
            c.sent++;
        } else if (data[i].status === "pending") {
            c.pending++;
        }

    }
    c.acceptedRight_pct = (c.acceptedRight * 100) / (c.acceptedRight + c.acceptedWrong);
    c.acceptedWrong_pct = (c.acceptedWrong * 100) / (c.acceptedRight + c.acceptedWrong);
    /*
     for (var [key, value] of c.sportRight.entries()) {
     console.log("challenge right: " + key + " = " + value);
     }
     for (var [key, value] of c.sportWrong.entries()) {
     console.log("challenge wrong: " + key + " = " + value);
     }
     */
    return c;
}

function findChallenge(game_id) {
    var foundPick = false;
    var index;
    if (passData.picks) {
        for (index = 0; index < passData.picks.length; index++) {
            if (passData.picks[index].game_id === game_id) {
                foundPick = true;
                break;
            }
        }
    }
    if (foundPick) {
        return index;
    } else {
        return -1;
    }
}
function ValidateEmail(inputText) {
    var mailformat = /^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,15})+$/;
    if (inputText.match(mailformat)) {
        return true;
    } else {
        return false;
    }
}

String.prototype.hashCode = function () {
    var hash = 0, i, chr, len;
    if (this.length === 0)
        return hash;
    for (i = 0, len = this.length; i < len; i++) {
        chr = this.charCodeAt(i);
        hash = ((hash << 5) - hash) + chr;
        hash |= 0; // Convert to 32bit integer
    }
    return hash;
};

// SuccessGPS Geolocation
//
function SuccessGPS(position) {

//console.log("Phonegap SuccessGPS");
}

// ErrorGPS Callback receives a PositionError object
//
function ErrorGPS(error) {
//console.log("Phonegap ErrorGPS");
}
/* Set the width of the side navigation to 250px */
function openMenuNav() {
    document.getElementById("menuNav").style.width = "250px";
}

/* Set the width of the side navigation to 0 */
function closeMenuNav() {
    document.getElementById("menuNav").style.width = "0";
}

function openPrefNav() {
    document.getElementById("prefNav").style.width = "250px";
}

/* Set the width of the side navigation to 0 */
function closePrefNav() {
    document.getElementById("prefNav").style.width = "0";
}

function ctrlInit(title, scope, location, route, timeout) {
    if (talkNew.length > 0) {
        scope.showTalkIcon = true;
    } else {
        scope.showTalkIcon = false;
    }
    if (GuserInfo.Id === "...") {
        location.path("/appStart");
    }
    scope.pageTitle = title;
    if (passData.userInfo.username === "none") {
        scope.myName = GuserInfo.Name;
    } else {
        scope.myName = passData.userInfo.username;
    }
    scope.footerTab = footerInit(scope, "footer");
    scope.footerClick = function (tabNumber) {
        footerGo(location, tabNumber);
    };
    scope.pathReload = function () {
        timeout(function () {
            //         $window.location.reload();
            route.reload();
        }, 50);
    };
    currentScope = scope;
}
function tabInit(cnt, select, style) {
    var tab = [];
    for (var i = 0; i < cnt; i++) {
        if (i === select) {
            tab[i] = {style: style + '-selected',
                show: true};
        } else {
            tab[i] = {style: style + '-option',
                show: false};
        }
    }
    return tab;
}
function tabDisplay(scope, tabNumber, style) {
    for (var i = 0; i < scope.tab.length; i++) {
        if (tabNumber === i) {
            scope.tab[i].show = true;
            scope.tab[i].style = style + '-selected';
        } else {
            scope.tab[i].show = false;
            scope.tab[i].style = style + '-option';
        }
    }
}
function nextTab(scope, lastTab, tabCnt) {
    var tabNumber = (lastTab + 1) % tabCnt;
    scope.tabClick(tabNumber);
}
function prevTab(scope, lastTab, tabCnt) {
    var tabNumber = 0;
    if (lastTab === 0) {
        tabNumber = tabCnt - 1;
    } else {
        tabNumber = (lastTab - 1) % tabCnt;
    }
    scope.tabClick(tabNumber);
}
function sportTabDisplay(scope, tabNumber, style) {
    for (var i = 0; i < scope.sportTab.length; i++) {
        if (tabNumber === i) {
            scope.sportTab[i].show = true;
            scope.sportTab[i].style = style + '-selected';
        } else {
            scope.sportTab[i].show = false;
            scope.sportTab[i].style = style + '-option';
        }
    }
}
function todayDate() {
    var currentDate = new Date();
    var day = currentDate.getDate();
    var year = currentDate.getYear() - 100;
    var month = currentDate.getMonth();
    if (day < 10) {
        day = "0".concat(day);
    }
    month = month + 1;
    if (month < 10) {
        month = "0".concat(month);
    }
    var d = "20".concat(year).concat("-").concat(month).concat("-").concat(day);
    return d;
}

function footerInit(scope, style) {
    var tab = [];
    for (var i = 0; i < footerCnt; i++) {
        if (footerSel === i) {
            tab[i] = {style: style + '-selected'};
        } else {
            tab[i] = {style: style + '-option'};
        }
    }
    return tab;
}
function footerGo(location, tabNumber) {
    footerSel = tabNumber;
    switch (tabNumber) {
        case 0:
            location.path("/homePage");
            break;
        case 1:
            location.path("/getGames");
            break;
        case 2:
            location.path("/myPicks");
            break;
        case 3:
            location.path("/getChallenges/true");
            break;
        case 4:
            location.path("/getChallenges/false");
            break;
    }
}

function findSportUrl(sport) {
    for (var i = 0; i < passData.sports.length; i++) {
        if (sport === passData.sports[i].sport)
            return passData.sports[i].sportUrl;
    }
}

function ckVersion(location, data) {
    if (data.data.version) {
        location.path("/update");
        return true;
    }
    return false;
}

function findEmailIndex(email, array) {
    for (var i = 0; i < array.length; i++) {
        if (email === array[i].userEmail) {
            return(i);
        }
    }
    return(-1);
}

function resetUserInfo() {
    GuserInfo = {
        Type: 'Google',
        Token: null,
        Id: '...',
        Name: '...',
        GivenName: '...',
        FamilyName: '...',
        ImageUrl: '...',
        Email: '...',
        AppVersion: appVersion
    };
    var SaveUserInfo = angular.toJson(GuserInfo);
    localStorage.SaveUserInfo = SaveUserInfo;
    passData = "";
    access_token = null;
    lastUpdate = {
        challenge: 0,
        getGames: 0,
        rank: 0,
        pick: 0
    };
    saveRankData = "";
    talkNew = [];
    talkFriendSave = {userName: "",
        userEmail: "",
        index: -1};
    refreshGames = false;
    recentTime = null;
    auth2 = null;
    loginCompleted = false;
    detailCompleted = false;
    gdd = null; //Game Day Data
    gameDay = "";
    currentPickIndex;
    contactNames = [];
    contactEmails = [];
    dtSave = null;
    adCnt = {
        pick: 0,
        cha: 0
    };
    lastSched = {
        dt: null,
        sport: "mlb",
        team: ""
    };
    lastSetting = {
        getGamesTab: 0,
        myPicksTab: 0,
        statsTab: 0,
        challengeTab: 0,
        filterTab: 0,
        sportTab: 0
    };
    footerSel = 0;
    footerCnt = 5;
    token = null;
}

function openExternal(elem) {
    window.open(elem.href, "_system");
    return false; // Prevent execution of the default onClick handler 
}